<!DOCTYPE html>
<html>
<head>
    <title>Task 62</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container pt-5">
        <div class="jumbotron container"> 
            <div class="row form-group">
                <div class="col-sm-2"></div>
                <div class="col-sm-2">
                    <label for="select-province" class="form-control border-0 bg-transparent text-primary">Tỉnh, Thành phố</label>
                </div>
                <div class="col-sm-6">
                    <select id="select-province" class="form-control border-primary">
                        <option value="none">--Chọn--</option>
                    </select>
                </div>
                <div class="col-sm-2"></div>
            </div>
            <div class="row form-group">
                <div class="col-sm-2"></div>
                <div class="col-sm-2">
                    <label for="select-district" class="form-control border-0 bg-transparent text-primary">Quận, huyện</label>
                </div>
                <div class="col-sm-6">
                    <select id="select-district" class="form-control border-primary" disabled>
                        <option value="none">------</option>
                    </select>
                </div>
                <div class="col-sm-2"></div>
            </div>
            <div class="row form-group">
                <div class="col-sm-2"></div>
                <div class="col-sm-2">
                    <label for="select-ward" class="form-control border-0 bg-transparent text-primary">Phường, xã</label>
                </div>
                <div class="col-sm-6">
                    <select id="select-ward" class="form-control border-primary" disabled>
                        <option value="none">------</option>
                    </select>
                </div>
                <div class="col-sm-2"></div>
            </div>
        </div>
    </div>
</body>
<script>
$(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    onPageLoading();
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // gán sự kiện change cho select province
    $('#select-province').on('change', function(){
        onBtnChangeProvinceSelect();
    });
    // gán sự kiện change cho select district
    $('#select-district').on('change', function(){
        onBtnChangeDistrictSelect();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        "use strict";
        $.ajax({
            url: "http://localhost:8080/province",
            type: "GET",
            dataType: 'json',
            async: false,
            success: function(responseObject){

                console.log(responseObject);
                for(var bI = 0; bI < responseObject.length; bI ++){
                    $('#select-province').append($('<option>', {
                        value: responseObject[bI].id,
                        text: responseObject[bI].name
                    }));
                }
            },
            error: function(error){
                console.log(error.responseText);
            }
        });
    }

    // Hàm xử lý khi change select province
    function onBtnChangeProvinceSelect(){
        "use strict";  
        var vProvinceId = $("#select-province").val(); // lấy ra provinceId từ select đc chọn
        console.log("provinceID được chọn: " + vProvinceId);
        if(vProvinceId != "none"){
            //Gọi APi theo provinceID
            $.ajax({
                url: "http://localhost:8080/province-info?districtId=" + vProvinceId,
                type: "GET",
                dataType: 'json',
                success: function(res){
                    console.log(res);
                    $('#select-district').empty(); // Làm rỗng dữ liệu select district trước khi đổ dữ liệu vào
                    $('#select-district').removeAttr("disabled"); // Gỡ bỏ thuộc tính disabled
                    for(var bI = 0; bI < res.length; bI ++){
                        $('#select-district').append($('<option>', {
                            value: res[bI].id,
                            text: res[bI].prefix + " " + res[bI].name
                        }));
                    }   
                },
                error: function(error){
                    console.log(error.responseText);
                }
            });
        } else {
            $('#select-district').attr("disabled", "disabled").empty().append($('<option>', {
                value: "none",
                text: "------"
            }));
            $('#select-ward').attr("disabled", "disabled").empty().append($('<option>', {
                value: "none",
                text: "------"
            }));
        }
    }
    // Hàm xử lý khi change select district
    function onBtnChangeDistrictSelect(){
        "use strict";  
        var vDistrictId = $("#select-district").val(); // lấy ra districtId từ select đc chọn
        console.log("districtId được chọn: " + vDistrictId);
        //Gọi APi theo districtId
        $.ajax({
            url: "http://localhost:8080/district-info?id=" + vDistrictId,
            type: "GET",
            dataType: 'json',
            success: function(res){
                console.log(res);
                $('#select-ward').empty(); // Làm rỗng dữ liệu select district trước khi đổ dữ liệu vào
                $('#select-ward').removeAttr("disabled"); // Gỡ bỏ thuộc tính disabled
                for(var bI = 0; bI < res.length; bI ++){
                    $('#select-ward').append($('<option>', {
                        value: res[bI].wardId,
                        text: res[bI].prefix + " " + res[bI].name
                    }));
                }   
            },
            error: function(error){
                console.log(error.responseText);
            }
        });
    }
});
</script>
</html>